// Design: Multiplicador secuencial
// Description: Unidad de control del multiplicador
// Author: Paulino Ruiz de Clavijo Vázquez <paulino@dte.us.es>
// Copyright Universidad de Sevilla, Spain
// Rev: 1, mar 2011

module u_control(
 input xs,clk,reset,busc0,cycont,
 output reg clsincr,fin,
 output reg wa,wd,wsuml,wsumh,shrsum,upcont
    );


 // Defina aqui la lista de estados con la sentencia parameter
  
 ...

 // Defina aqui dos variables  tipo reg llamadas: 
 //     estado_actual y siguiente_estado
 // Dimensione ambas variables con el tamaño correcto en función
 // del número de estados que definió previamente

   
 ...

 // Proceso de cambio de estado, utiliza la variables
 // definidas previamente
 always @(posedge clk,posedge reset)
  begin
   if(reset)
   estado_actual <= S0;
  else
   estado_actual <= siguiente_estado;
  end
  
  // Proceso combinacional de calculo de proximo estado
  // debe obtenerlos a partir de la carta ASM 
  always @(*)
  begin
   clsincr=0; // Por defecto se establecen todas las señales a cero
   wa=0;
   wd=0;
   wsuml=0;
   wsumh=0;
   upcont=0;
   shrsum=0;
   fin=0;
   case(estado_actual)
         // Rellene todos los estados y active las señales de control
         // siguiendo la carta ASM
      S0:
        if(xs)
          begin
          clsincr=1;
          siguiente_estado = S1;
          end
        else
          siguiente_estado = S0;

       // Aqui deben ir el resto de estados
       ....
       ///

      default:  // No elimine esta sentencia para evitar problemas
          siguiente_estado=S0;  // Cuidado aqui, hay que cubrir todos los casos 
                                // de lo contrario aparece un latch
  endcase
  end
endmodule
